/***************************************************************************
                    qrdialog.cpp  -  description
                           -------------------
  begin                : Sat Aug 18 13:58:51 JST 2001
  copyright            : (C) 2001 by Nobuyuki Horie
  email                : horie@smail.u-shizuoka-ken.ac.jp
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/*
 * $Id: qrdialog.cpp,v 1.1.1.1 2002/12/22 14:20:12 taka-hr Exp $
 * Purpose: 
 * Author:  
 */
 
#include "qrbfunction.h"
#include "qrdialog.h"
#include "swig_class_qte.h"


/**
*/
QRDialog::QRDialog ( QWidget * parent, const char * name, bool modal, WFlags f):
QDialog(parent,name,modal,f),ruby_obj(Qnil)
{
//   initSelf(); //Do not work?	
}

/**
*/
QRDialog::~QRDialog()
{	
}
/**
*/
void QRDialog::setSelf(VALUE self)
{
   ruby_obj = self;	
}

void QRDialog::initSelf()
{
   ruby_obj = Data_Wrap_Struct(cQRDialog.klass,0,0,this);
}


void QRDialog::setResult(int r)
{
   QDialog::setResult(r);
}

void QRDialog::done(int r)
{
   if(ruby_obj != Qnil && ruby_respondTo(ruby_obj,"done")) {
   rb_funcall(ruby_obj,rb_intern("done"),1,INT2NUM(r));
   } else {
   //QDialog::done(r);
   }   
}
void QRDialog::accept()
{
   if(ruby_obj != Qnil && ruby_respondTo(ruby_obj,"accept")) {
   rb_funcall(ruby_obj,rb_intern("accept"),0,0);
   } else {
   //QDialog::accept();
   }      
}
void QRDialog::reject()
{
   if(ruby_obj != Qnil && ruby_respondTo(ruby_obj,"reject")) {
   rb_funcall(ruby_obj,rb_intern("done"),0,0);
   } else {
   //QDialog::reject();
   }   
}


#ifndef QT_NO_FILEDIALOG
/**
*/
QRFileDialog::QRFileDialog( const QString& dirName, const QString& filter,
                 QWidget *parent, const char *name, bool modal):
QFileDialog(dirName,filter,parent,name,modal),ruby_obj(Qnil)
{
//   initSelf(); // Do not work?
}
QRFileDialog::QRFileDialog( QWidget *parent, const char *name, bool modal):
QFileDialog(parent,name,modal),ruby_obj(Qnil)
{
}
/**
*/
QRFileDialog::~QRFileDialog()
{	
}
/**
*/
void QRFileDialog::setSelf(VALUE self)
{
   ruby_obj = self;	
}

void QRFileDialog::initSelf()
{
   ruby_obj = Data_Wrap_Struct(cQRFileDialog.klass,0,0,this);
}

void QRFileDialog::setResult(int r)
{
   QDialog::setResult(r);
}

void QRFileDialog::done(int r)
{
   if(ruby_obj != Qnil && ruby_respondTo(ruby_obj,"done")) {
   rb_funcall(ruby_obj,rb_intern("done"),1,INT2NUM(r));
   } else {
   //QFileDialog::done(r);
   }  
}
void QRFileDialog::accept()
{
   if(ruby_obj != Qnil && ruby_respondTo(ruby_obj,"accept")) {
   rb_funcall(ruby_obj,rb_intern("accept"),0,0);
   } else {
   //QFileDialog::accept();
   }      
}
void QRFileDialog::reject()
{
   if(ruby_obj != Qnil && ruby_respondTo(ruby_obj,"reject")) {
   rb_funcall(ruby_obj,rb_intern("done"),0,0);
   } else {
   //QFileDialog::reject();
   }   
}

#endif
