/***************************************************************************
                    qrmovie.cpp  -  description
                           -------------------
  begin                : Sat Aug 18 13:58:51 JST 2001
  copyright            : (C) 2001 by Nobuyuki Horie
  email                : horie@smail.u-shizuoka-ken.ac.jp
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/*
 * $Id: qrmovie.cpp,v 1.1.1.1 2002/12/22 14:20:13 taka-hr Exp $
 * Purpose: 
 * Author:  
 */
#include "qrobject.h"
#include "qrmovie.h"
#include "rslot.h"


/**
*/
QRMovie::QRMovie(): QMovie()
{
	
}

/**
*/
QRMovie::~QRMovie()
{
	
}

/**
*/
QRMovie::QRMovie( QDataSource * qds, int bufsize)
	:QMovie( qds, bufsize )
{
	
}

/**
*/
QRMovie::QRMovie( const char * fileName, int bufsize )
	:QMovie( fileName, bufsize ) 
{
	
}

/**
*/
QRMovie::QRMovie ( QByteArray data, int bufsize )
	:QMovie ( data, bufsize )
{
	
}

/**
*/
RSlot& QRMovie::connectResize (VALUE receiver, char * member )   
{
   RSlot * rubySlot;
   rubySlot = QRObject::make_rslot("SLOT(const QSize&)",
   	receiver,member); 
   //new RSlotQSize(receiver,member);
   QMovie::connectResize(rubySlot,rubySlot->qslot());
   return *rubySlot;   	
}

/**
*/
void QRMovie::disconnectResize ( RSlotQSize& ruby_slot )
{
  QMovie::disconnectResize(&ruby_slot,SLOT(rslot(const QSize&)));	
}

/**
*/
RSlot& QRMovie::connectUpdate ( VALUE receiver, char * member ) 
{
   RSlot* rubySlot;
   rubySlot = QRObject::make_rslot("SLOT(const QRect&)",
   	receiver,member);  
   //new RSlotQRect(receiver,member);
   QMovie::connectUpdate(rubySlot,rubySlot->qslot());
   return *rubySlot;	
}

/**
*/
void QRMovie::disconnectUpdate ( RSlotQRect & ruby_slot )
{
   QMovie::disconnectUpdate(&ruby_slot,SLOT(rslot(const QRect&)));	
}

/**
*/
RSlot& QRMovie::connectStatus ( VALUE receiver, char * member )
{
   RSlot* rubySlot;
   rubySlot = QRObject::make_rslot("SLOT(int)",
   	receiver,member);
   //new RSlotInt(receiver,member);
   QMovie::connectStatus(rubySlot,SLOT(rslot(int)));
   return *rubySlot;	
}

/**
*/
void QRMovie::disconnectStatus ( RSlotInt& ruby_slot ) 
{
   QMovie::disconnectStatus(&ruby_slot,SLOT(rslot(int)));	
}
