/****************************************************************************
** $Id: qstatusbar.i,v 1.1.1.1 2002/12/22 14:20:14 taka-hr Exp $
**
** Definition of QStatusBar class
**
** Created : 980316
**
** Copyright (C) 1992-2000 Troll Tech AS.  All rights reserved.
**
** This file is part of the Qt GUI Toolkit.
**
** This file may be distributed under the terms of the Q Public License
** as defined by Troll Tech AS of Norway and appearing in the file
** LICENSE.QPL included in the packaging of this file.
**
** Licensees holding valid Qt Professional Edition licenses may use this
** file in accordance with the Qt Professional Edition License Agreement
** provided with the Qt Professional Edition.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about the Professional Edition licensing, or see
** http://www.trolltech.com/qpl/ for QPL licensing information.
**
*****************************************************************************/

//#ifndef QSTATUSBAR_H
//#define QSTATUSBAR_H

//#ifndef QT_H
//#include "qwidget.h"
//#endif // QT_H


class QStatusBarPrivate;


class QStatusBar: public QWidget
{
//    Q_OBJECT
public:
		QStatusBar( QWidget * parent = 0, const char *name = 0 );
//    ~QStatusBar();

		void addWidget( QWidget *, int stretch = 0, bool flag = FALSE );
		void removeWidget( QWidget * );

		void setSizeGripEnabled(bool);
		bool isSizeGripEnabled() const;

//public slots:
//    void message( const QString &);

		//RENAME %name(messageQStringInt) void message( const QString &, int );
		%extend {
			 void message(VALUE varg0,VALUE varg1=Qnil) {
					QString* qstr;
					qstr = (QString *)Get_QString(varg0);
					if(varg1 == Qnil) {
						 self->message(*qstr);
					} else {
						 int ms;
						 ms = NUM2INT(varg1);
						 self->message(*qstr,ms);
					}
			 }
		}

		void clear();

/*
protected:
		void paintEvent( QPaintEvent * );
		void resizeEvent( QResizeEvent * );

		void reformat();
		void hideOrShow();
		bool event( QEvent *);
private:
		QStatusBarPrivate * d;
private:	// Disabled copy constructor and operator=
#if defined(Q_DISABLE_COPY)
		QStatusBar( const QStatusBar & );
		QStatusBar& operator=( const QStatusBar & );
#endif
*/
};


//#endif
