/****************************************************************************
** $Id: qvaluelist.i,v 1.1.1.1 2002/12/22 14:20:18 taka-hr Exp $
**
** Definition of QValueList class
**
** Created : 990406
**
** Copyright (C) 1992-2000 Troll Tech AS.  All rights reserved.
**
** This file is part of the Qt GUI Toolkit.
**
** This file may be distributed under the terms of the Q Public License
** as defined by Troll Tech AS of Norway and appearing in the file
** LICENSE.QPL included in the packaging of this file.
**
** Licensees holding valid Qt Professional Edition licenses may use this
** file in accordance with the Qt Professional Edition License Agreement
** provided with the Qt Professional Edition.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about the Professional Edition licensing, or see
** http://www.trolltech.com/qpl/ for QPL licensing information.
**
*****************************************************************************/

//#ifndef QVALUELIST_H
//#define QVALUELIST_H

//#ifndef QT_H
//#include "qshared.h"
//#include "qdatastream.h"
//#endif // QT_H

//#if defined(_CC_MSVC_)
//#pragma warning(disable:4284) // "return type for operator -> is not a UDT"
//#endif

//template <class T>
class QValueListNode
{
public:
//    QValueListNode( const T& t ) : data( t ) { }
//    QValueListNode() { }
//#if defined(Q_TEMPLATEDLL)
		// Workaround MS bug in memory de/allocation in DLL vs. EXE 
//    virtual ~QValueListNode() { }
//#endif

//    QValueListNode<T>* next;
//    QValueListNode<T>* prev;
//    T data;
};

//template<class T>
class  QValueListIterator
{

};

//template<class T>
class QValueListConstIterator
{

};

//template <class T>
/*
class Q_EXPORT QValueListPrivate : public QShared
{

};
*/
//template <class T>
class QValueList
{
public:
		/**
		 * Typedefs
		 */
//    typedef QValueListIterator<T> Iterator;
//    typedef QValueListConstIterator<T> ConstIterator;
//    typedef T ValueType;

		/**
		 * API
		 */
//    QValueList() { sh = new QValueListPrivate<T>; }
//    QValueList( const QValueList<T>& l ) { sh = l.sh; sh->ref(); }
//    ~QValueList() { sh->derefAndDelete(); }
/*
		QValueList<T>& operator= ( const QValueList<T>& l )
		{
	l.sh->ref();
	sh->derefAndDelete();
	sh = l.sh;
	return *this;
		}

		QValueList<T> operator+ ( const QValueList<T>& l ) const
		{
	QValueList<T> l2( *this );
	for( ConstIterator it = l.begin(); it != l.end(); ++it )
	    l2.append( *it );
	return l2;
		}

		QValueList<T>& operator+= ( const QValueList<T>& l )
		{
	for( ConstIterator it = l.begin(); it != l.end(); ++it )
	    append( *it );
	return *this;
		}

		bool operator== ( const QValueList<T>& l ) const
		{
	if ( count() != l.count() )
	    return FALSE;
	ConstIterator it2 = begin();
	ConstIterator it = l.begin();
	for( ; it != l.end(); ++it, ++it2 )
	    if ( !( *it == *it2 ) )
		return FALSE;
	return TRUE;
		}

		bool operator!= ( const QValueList<T>& l ) const { return !( *this == l ); }

		Iterator begin() { detach(); return Iterator( sh->node->next ); }
		ConstIterator begin() const { return ConstIterator( sh->node->next ); }
		Iterator end() { detach(); return Iterator( sh->node ); }
		ConstIterator end() const { return ConstIterator( sh->node ); }
		Iterator fromLast() { detach(); return Iterator( sh->node->prev ); }
		ConstIterator fromLast() const { return ConstIterator( sh->node->prev ); }
*/
//    bool isEmpty() const { return ( sh->nodes == 0 ); }
/*
		Iterator insert( Iterator it, const T& x ) { detach(); return sh->insert( it, x ); }

		Iterator append( const T& x ) { detach(); return sh->insert( end(), x ); }
		Iterator prepend( const T& x ) { detach(); return sh->insert( begin(), x ); }

		Iterator remove( Iterator it ) { detach(); return sh->remove( it ); }
		void remove( const T& x ) { detach(); sh->remove( x ); }

		T& first() { detach(); return sh->node->next->data; }
		const T& first() const { return sh->node->next->data; }
		T& last() { detach(); return sh->node->prev->data; }
		const T& last() const { return sh->node->prev->data; }

		T& operator[] ( uint i ) { detach(); return sh->at(i)->data; }
		const T& operator[] ( uint i ) const { return sh->at(i)->data; }
		Iterator at( uint i ) { detach(); return Iterator( sh->at(i) ); }
		ConstIterator at( uint i ) const { return ConstIterator( sh->at(i) ); }
		Iterator find ( const T& x ) { detach(); return Iterator( sh->find( sh->node->next, x) ); }
		ConstIterator find ( const T& x ) const { return ConstIterator( sh->find( sh->node->next, x) ); }
		Iterator find ( Iterator it, const T& x ) { detach(); return Iterator( sh->find( it.node, x ) ); }
		ConstIterator find ( ConstIterator it, const T& x ) const { return ConstIterator( sh->find( it.node, x ) ); }
*/
//    int findIndex( const int & x ) const; // { return sh->findIndex( sh->node->next, x) ; }
//    uint contains( const int & x ) const; // { return sh->contains( x ); }

//    uint count() const; // { return sh->nodes; }

//    void clear(); //{ if ( sh->count == 1 ) sh->clear(); else { sh->deref(); sh = new QValueListPrivate<T>; } }

/*
		QValueList<T>& operator+= ( const T& x )
		{
	append( x );
	return *this;
		}
		QValueList<T>& operator<< ( const T& x )
		{
	append( x );
	return *this;
		}

*/
//protected:
		/**
		 * Helpers
		 */
//    void detach() { if ( sh->count > 1 ) { sh->deref(); sh = new QValueListPrivate<T>( *sh ); } }

		/**
		 * Variables
		 */
//    QValueListPrivate<T>* sh;
};

class QValueList_int : public QValueList {
	 public:
		QValueList_int();
		~QValueList_int();
		bool isEmpty() const; 
		void remove( const int& x ); 

		int& first(); 
		int& last(); 
		int findIndex( const int & x ) const; 
		uint contains( const int & x ) const; 

		uint count() const; 

		void clear(); 
		%extend{
			 int at( uint i) const {
					QValueListIterator<int> it;
					it = self->at(i);
					return *it;
			 }
			 int append( const int& i) {
					QValueListIterator<int> it;
					it = self->append(i);
					return *it;
			 }
			 int prepend( const int& i) {
					QValueListIterator<int> it;
					it = self->prepend(i);
					return *it;
			 }
			int __getitem__(int index) {
		  			return (*self)[index];
			}
			int __setitem__(int index, int value) {
		  			return (*self)[index] = value;
			}
		}   
	 };
class QValueList_QVariant : public QValueList {
	 public:
		QValueList_QVariant();
		~QValueList_QVariant();
		bool isEmpty() const; 
		void remove( const QVariant& x ); 

		QVariant& first(); 
		QVariant& last(); 
		int findIndex( const QVariant & x ) const; 
		uint contains( const QVariant & x ) const; 

		uint count() const; 

		void clear(); 
		%extend{
			 QVariant at( uint i) const {
					QValueListIterator<QVariant> it;
					it = self->at(i);
					return *it;
			 }
			 QVariant append( const QVariant& i) {
					QValueListIterator<QVariant> it;
					it = self->append(i);
					return *it;
			 }
			 QVariant prepend( const QVariant& i) {
					QValueListIterator<QVariant> it;
					it = self->prepend(i);
					return *it;
			 }
			QVariant __getitem__(int index) {
		  			return (*self)[index];
			}
			QVariant __setitem__(int index, QVariant value) {
		  			return (*self)[index] = value;
			}
		}   
	 };   
	 


//#endif
